OGRE-Next: Ogre::v1::HardwareIndexBuffer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | List of all members
Ogre::v1::HardwareIndexBuffer Class Reference
Core » RenderSystem

Specialisation of HardwareBuffer for vertex index buffers, still abstract. More...

`#include <OgreHardwareIndexBuffer.h>`

Inheritance diagram for Ogre::v1::HardwareIndexBuffer:
[legend]

## Public Types
typedef Ogre::IndexType | IndexType
Public Types inherited from Ogre::v1::HardwareBuffer
enum | LockOptions { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1 , HBU_DYNAMIC = 2 , HBU_WRITE_ONLY = 4 , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = 5 , HBU_DYNAMIC_WRITE_ONLY = 6 , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...

## Public Member Functions
| HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareIndexBuffer ()
size_t | getIndexSize () const
| Get the size in bytes of each index.
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getNumIndexes () const
| Get the number of indexes in this buffer.
IndexType | getType () const
| Get the type of indexes used in this buffer.
Public Member Functions inherited from Ogre::v1::HardwareBuffer
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void | _updateFromShadow ()
| Updates the real buffer from the shadow buffer, if required.
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void * | getRenderSystemData ()
| An internal function that should be used only by a render system for internal use.
size_t | getSizeInBytes () const
| Returns the size of this buffer in bytes.
Usage | getUsage () const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer () const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked () const
| Returns whether or not this buffer is currently locked.
bool | isSystemMemory () const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
virtual void | readData (size_t offset, size_t length, void *pDest)=0
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
virtual void | unlock ()
| Releases the lock on this buffer.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)=0
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

## Static Public Attributes
static const IndexType | IT_16BIT = Ogre::IT_16BIT
static const IndexType | IT_32BIT = Ogre::IT_32BIT

## Detailed Description

Specialisation of HardwareBuffer for vertex index buffers, still abstract.

## Member Typedef Documentation

## ◆ IndexType

typedef Ogre::IndexType Ogre::v1::HardwareIndexBuffer::IndexType

## Constructor & Destructor Documentation

## ◆ HardwareIndexBuffer()

Ogre::v1::HardwareIndexBuffer::HardwareIndexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | IndexType | idxType,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useSystemMemory,
|  | bool | useShadowBuffer )

Should be called by HardwareBufferManager.

## ◆ ~HardwareIndexBuffer()

Ogre::v1::HardwareIndexBuffer::~HardwareIndexBuffer | ( |  | ) |

## Member Function Documentation

## ◆ getIndexSize()

size_t Ogre::v1::HardwareIndexBuffer::getIndexSize | ( |  | ) | const
| inline

Get the size in bytes of each index.

Referenced by Ogre::VerticesRemapInfo::performIndexDataRemap().

## ◆ getManager()

HardwareBufferManagerBase * Ogre::v1::HardwareIndexBuffer::getManager | ( |  | ) | const
| inline

Return the manager of this buffer, if any.

## ◆ getNumIndexes()

size_t Ogre::v1::HardwareIndexBuffer::getNumIndexes | ( |  | ) | const
| inline

Get the number of indexes in this buffer.

## ◆ getType()

IndexType Ogre::v1::HardwareIndexBuffer::getType | ( |  | ) | const
| inline

Get the type of indexes used in this buffer.

Referenced by Ogre::VerticesRemapInfo::performIndexDataRemap().

## Member Data Documentation

## ◆ IT_16BIT

const IndexType Ogre::v1::HardwareIndexBuffer::IT_16BIT = Ogre::IT_16BIT
| static

Referenced by Ogre::VerticesRemapInfo::performIndexDataRemap().

## ◆ IT_32BIT

const IndexType Ogre::v1::HardwareIndexBuffer::IT_32BIT = Ogre::IT_32BIT
| static

Referenced by Ogre::VerticesRemapInfo::markUsedIndices(), and Ogre::VerticesRemapInfo::performIndexDataRemap().

The documentation for this class was generated from the following file:

- OgreHardwareIndexBuffer.h